
 /* OldReadDir V38.1                                           */
 /* FREEWARE.                                                  */
 /* (c) 1993 by Andreas R. Kleinert.                           */
 /* Demonstrates use of the "AK_ReadDir()" function.           */
 /* This function is actually OBSOLETE and you should          */
 /* use "AK_GetDirList()" instead, if possible.                */
 /* Written in SAS/C V6.00 for OS V2.04 (V37) Includes.        */

#include <ak_gen0/ak_gen0_pragma.h>

#include <stdlib.h>

#include <proto/exec.h>
#include <proto/intuition.h>

void main(long argc, char **argv) /* MAIN */
{
 printf("\nOldReadDir V38.1, FREEWARE, (c) 1993 by Andreas R. Kleinert.\n");

 AKBase = (struct AKBase *) OpenLibrary("ak_gen0.library", 37); /* minimum */
 if(AKBase)
  {
   char *direntry[AK_MAX_READDIR_ENTRIES];
   long dirtype [AK_MAX_READDIR_ENTRIES], count, i;

   for(i=0; i<AK_MAX_READDIR_ENTRIES; i++) direntry[i] = (APTR) AllocMem(AK_MAX_DOS_FILENAME_LEN, MEMF_CLEAR);

   if(direntry[i-1]) /* enough memory for all entries (test last one) ? */
    {
     if(argv[1]) count = AK_ReadDir(argv[1], &direntry[0], &dirtype[0]);
      else       count = AK_ReadDir(     "", &direntry[0], &dirtype[0]);
 
     for(i=0; i<=count; i++)
     {
      printf("\n %ld : %s", i, direntry[i]);

      if(dirtype[i] == AKF_IS_DIR) printf(" (DIR)");
      }

     printf("\n\n");
    }

   for(i=0; i<AK_MAX_READDIR_ENTRIES; i++) if(direntry[i]) FreeMem(direntry[i], AK_MAX_DOS_FILENAME_LEN);

   CloseLibrary((APTR) AKBase);
  }else
  {
   printf("\n Can't open \42ak_gen0.library\42 V37+ !\n");
  }

 exit(0);
}
